<CsoundSynthesizer>
<CsOptions>
-d 
</CsOptions>

<CsInstruments>
; moogladder opcode example
; by Victor Lazzarini

; modified by A. Kozar for non-FLTK use

sr=44100
kr=4410
ksmps=10
nchnls=1


gks init 1
gks2 init 2
gamix init 0 

; these defaults added by A. Kozar as a substitute for the FLTK opcodes
gk1	init	4000		; filter cutoff
gk2	init	0		; filter resonance
gk3	init	-12		; osc 1 level
gk4	init	1		; osc 1 on
gk5	init	220		; osc 1 pitch
gk6	init	1		; osc 2 on
gk7	init	440		; osc 2 pitch
gk8	init	-12		; osc 2 level
gk9	init	-90		; noise level
gk10	init	-90		; input level

;/* oscillator panels */
;
;FLcolor  200,10,40, 140,60,60
;FLpanel "osc 1", 150, 100, 200, 200
;FLcolor  10,100,180,255,160,100
;gk4, ib4 FLbutton "on", 1, 0, 2, 50, 30, 10, 10, 105, gks, 0, -1, 16000, 200
;FLcolor  10,100,180,180,0,0
;gk5, ik5 FLknob	  "pitch", 20, 2000, -1, 1, -1, 50, 80, 10
;FLsetVal_i  200, ik5
;FLcolor  200,10,40,200,10,40
;ib1	FLbox	"saw", 1, 1, 16, 50, 30, 10, 52
;FLpanelEnd
;
;FLcolor  200,10,40, 140,60,60
;FLpanel "osc 2", 150, 100, 200, 340
;FLcolor  10,100,180,255,160,100
;gk6, ib6 FLbutton "on", 1, 0, 2, 50, 30, 10, 10, 105, gks2, 0, -1, 32000, 200
;FLcolor  10,100,180,180,0,0
;gk7, ik7 FLknob	  "pitch", 20, 2000, -1, 1, -1, 50, 80, 10
;FLsetVal_i  200, ik7
;FLcolor  200,10,40,200,10,40
;ib1	FLbox	"pulse", 1, 1, 16, 50, 30, 10, 52
;FLpanelEnd
;
;/* filter panel */
;FLcolor  200,10,40, 140,60,60
;FLpanel "moog ladder filter", 250, 100, 380, 340
;FLcolor  255,255,255,255,255,255
;iv1 FLvalue  " ", 50, 20, 160, 10
;iv2 FLvalue  " ", 50, 20, 160, 60
;FLcolor  200,10,40, 140,60,60
;gk1, is1 FLslider "cutoff frequency", 1, 20000, -1, 5, iv1, 140, 10, 10, 10
;gk2, is2 FLslider "resonance",        0,     1,  0, 5, iv2, 140, 10, 10, 60
;FLsetVal_i 1000, is1
;FLsetVal_i 0.5, is2
;FLpanelEnd
;
;/* mixer panel */
;gk3 init -90
;gk8 init -90
;gk9 init -90
;gk10 init -90
;FLcolor  200,10,40, 140,60,60
;FLpanel "mixer", 290, 100, 380, 200
;FLcolor  10,100,180,255,160,100
;gk3, ik3 FLknob	  "osc 1", -90, 0, 0, 1, -1,  50, 10, 10
;gk8, ik8 FLknob	  "osc 2", -90, 0, 0, 1, -1,  50, 80, 10
;gk9, ik9 FLknob	  "noise", -90, 0, 0, 1, -1,  50, 150, 10
;gk10, ik10 FLknob  "input", -90, 0, 0, 1, -1,  50, 220, 10
;FLsetVal_i -90, ik10
;FLsetVal_i -90, ik9
;FLsetVal_i -90, ik8
;FLsetVal_i -90, ik3
;FLrun 

;#include "moogladder.opcode"

instr 1

iamp = p4
ifund = p5
kamp init -90

kfun tonek gk5, 2
kamp tonek gk3, 2

asig  oscili  p4, kfun, 1
gamix = gamix +  asig*ampdb(kamp)
    
endin

instr 2

iamp = p4
ifund = p5
kamp init -90

kfun tonek gk7, 2
kamp tonek gk8, 2

asig   buzz  p4, kfun, sr/(2*kfun), 2
gamix = gamix +  asig*ampdb(kamp)
    
endin

instr 10

ain   in
anoi  rand  16000
kcf  tonek gk1, 2
kres tonek gk2, 2
knoi  tonek gk9, 2
kin   tonek gk10, 2
asig = gamix + anoi*ampdb(knoi) + ain*ampdb(kin)
afil moogladder   asig, kcf, kres
      out   afil

gamix = 0
endin

instr 100
gks = 1 - gk4*2
gks2 = 2 - gk6*4
endin

; added by A. Kozar to allow changing parameters without FLTK
instr 101
	gk1 = p4	; filter cutoff
	gk2 = p5	; filter resonance
	gk5 = p6	; osc 1 pitch (saw)
	gk7 = p7	; osc 2 pitch (pulse)
endin

</CsInstruments>
<CsScore>
f1 0 16384 10 1 .5 .4 .3 .2 .1 .05 .04 .03 .02 .01 .01 .01 .01
f2 0 16384 10 1

i10  0 10
;i100 0 60

; static notes by A. Kozar
i1 0 10 16000 1
i2 0 10 16000 2

i101 2 .1 1000  0.5 440 550
i101 3 .1 10000
i101 4 .1 2000  1.0 330 770
i101 7 .1 400   0.1 55  55

</CsScore>
</CsoundSynthesizer>
