<CsoundSynthesizer>
<CsOptions>
-d 
</CsOptions>

<CsInstruments>
; syncgrain opcode example
; by Victor Lazzarini

; modified by A. Kozar for non-FLTK use

sr = 44100
kr = 441
ksmps = 100
nchnls = 1

;FLcolor  200,10,40, 140,60,60
;
;	FLpanel	"Syncgrain",220,435,200,200
;FLcolor  140,10,40, 140,60,60
;iv1 FLvalue  "time ratio",  80, 20, 20, 240
;iv2 FLvalue  "pitch ratio", 80, 20, 110, 240
;FLcolor  140,60,60, 200,10,40
;gk1,gk2, ih1, ih2 FLjoy  "timescale x pitchscale",-2,2,2,-2,0,0,iv1,iv2, 200,200,10,10
;FLcolor  200,10,40, 140,60,60
;gk3, ih3  FLslider  "grain size (0.01-0.5 secs)", 0.01, 0.5,0,5,-1,200,20,10,295
;gk4, ih4  FLslider  "overlapped grains (1 - 50)", 1,50,0,5,-1,200,20,10,340
;gk5, ih5  FLslider  "amplitude", 1,32767,-1,5,-1,200,20,10,385
;
;FLsetVal_i -2, ih1
;FLsetVal_i 2, ih2
;FLsetVal_i 0.04, ih3
;FLsetVal_i 2, ih4
;FLsetVal_i 16000, ih5
;
;	FLpanelEnd
;	FLrun

gk1	init	.25	; timescale
gk2	init	.75	; pitchscale
gk3	init	.02	; grain size
gk4	init	12	; overlapping grains
gk5	init	5000	; amplitude

instr 1

iomax = 100          /* just to be in the safe side */
kol = int(gk4)       /* number of overlapped grains */
kgr = gk3            /* grain size in secs */
kfr = kol/kgr        /* freq or density in gr/sec */
kps = 1/kol          /* pointer rate scaling */

/* gk1 controls timescale, gk2 controls pitchscale */
asig syncgrain  gk5, kfr, gk2, kgr, kps*gk1,1, 2, iomax

   out   asig

endin

</CsInstruments>

<CsScore>
f1 0 0 1 "Blackbird.aif" 0 0 1 
f2 0 1025 20 2 1

i1 0 20  

</CsScore>

</CsoundSynthesizer>