; shapetest.orc

sr      = 44100
kr      = 4410
ksmps	= 10
nchnls  = 1


; test instrument for phasine opcode
instr 1

	idur		= p3
	iamp		= p4
	ifreq		= p5
	ifn			= p6
	
	kenv		linseg	0, .05, 1.0, idur - .1, 1.0, .05, 0
	aosc		oscil	1.0, ifreq, ifn
	
	kmod		line	0.0, idur, 1.0
	aout		phasine	aosc, kmod, 1.0
	
				out		kenv*aout*iamp		
endin

; test instrument for powershape opcode
instr 2

	idur		= p3
	iamp		= p4
	ifreq		= p5
	ifn			= p6
	
	kenv		linseg		0, .05, 1.0, idur - .1, 1.0, .05, 0
	aosc		oscil		1.0, ifreq, ifn
	
	kmod		expon		2.0, idur, 20.0
	aout		powershape	aosc, kmod, 1.0
	
				out			kenv*aout*iamp		
endin

; test instrument for pdclip opcode
instr 3

	idur		= p3
	iamp		= p4
	ifreq		= p5
	ifn			= p6
	
	kenv		linseg		0, .05, 1.0, idur - .1, 1.0, .05, 0
	aosc		oscil		1.0, ifreq, ifn
	
	kmod		expseg		0.00001, idur, 1.0
	aout		pdclip		aosc, kmod, 0.0
	
				out			kenv*aout*iamp		
endin

; test instrument for pdhalf opcode
instr 4

	idur		= p3
	iamp		= p4
	ifreq		= p5
	
	kenv		linseg		0, .001, 1.0, idur - .051, 1.0, .05, 0
	aosc		phasor		ifreq
	kamount		linseg		1.0, 0.1, 0.9, 1.0, 0.0
	apd			pdhalf		2*aosc - 1.0, kamount
	aout		tablei		0.5*(apd+1.0), 1, 1
	
				out			kenv*aout*iamp		
endin

; test instrument for pdhalfy opcode
instr 5

	idur		= p3
	iamp		= p4
	ifreq		= p5
	iamtinit	= p6
	
	kenv		linseg		0, .05, 1.0, idur - .1, 1.0, .05, 0
	aosc		phasor		ifreq
	kamount		line		iamtinit, idur, 0.0
	apd			pdhalfy		2*aosc - 1.0, kamount
	aout		tablei		0.5*(apd+1.0), 1, 1
	
				out			kenv*aout*iamp		
endin
