sr      = 44100
kr      = 4410
ksmps	= 10
nchnls  = 1

; test instrument for syncslave opcode
instr 1

	idur		=	p3
	iamp		=	p4
	imasterfreq	= 	p5
	islavelow	=	p6
	islavehigh	= 	p7
	
	kenv		linseg		0, .05, 1.0, idur - .1, 1.0, .05, 0
	kslavefreq	linseg		islavelow, idur/2, islavehigh, idur/2, islavelow
	ainit		init		1.0
	amaster		syncslave	ainit, 1.0, imasterfreq
	aslave		syncslave	amaster, iamp, kslavefreq	
				out			aslave*kenv
endin

; test instrument for syncslave & syncmaster opcodes
; this instrument should function identically to instr 1
instr 2

	idur		=	p3
	iamp		=	p4
	imasterfreq	= 	p5
	islavelow	=	p6
	islavehigh	= 	p7
	
	kenv		linseg		0, .05, 1.0, idur - .1, 1.0, .05, 0
	kslavefreq	linseg		islavelow, idur/2, islavehigh, idur/2, islavelow
	amaster		syncmaster	imasterfreq
	aslave		syncslave	amaster, iamp, kslavefreq	
				out			aslave*kenv
endin

; test instrument for syncpair opcode
; this instrument should function identically to instr 1 & 2
instr 3

	idur		=	p3
	iamp		=	p4
	imasterfreq	= 	p5
	islavelow	=	p6
	islavehigh	= 	p7
	
	kenv		linseg		0, .05, 1.0, idur - .1, 1.0, .05, 0
	kslavefreq	linseg		islavelow, idur/2, islavehigh, idur/2, islavelow
	aslave		syncpair	iamp, imasterfreq, kslavefreq	
				out			aslave*kenv
endin

; test instrument for syncoscili opcode
; functions similarly to instr 1-3 but allows the use
; of an arbitrary waveform for the slave oscillator
instr 4

	idur		=	p3
	iamp		=	p4
	imasterfreq	= 	p5
	islavelow	=	p6
	islavehigh	= 	p7
	ifnum		=	p8		; ftable number for oscillator
	
	kenv		linseg		0, .05, 1.0, idur - .1, 1.0, .05, 0
	kslavefreq	linseg		islavelow, idur/2, islavehigh, idur/2, islavelow
	amaster		syncmaster	imasterfreq
	aslave		syncoscili	amaster, iamp, kslavefreq, ifnum
				out			aslave*kenv
endin
