/*	hardsync.h

	A Csound opcode library implementing ugens
	for hard sync.
	
	Anthony Kozar
	November 29, 2004

	Code for syncoscili borrowed from ugens2.c in canonical Csound

	Copyright (C) 1991,2004 Barry Vercoe, John ffitch,
	            Robin Whittle, and Anthony Kozar

	The hardsync opcode library is free software; you can redistribute it
	and/or modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	Csound is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with Csound; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
	02111-1307 USA
 */

#ifndef	ANTHONY_HARDSYNC_H
#define	ANTHONY_HARDSYNC_H

#include	"csdl.h"

typedef struct {
	OPDS	h;
	MYFLT	*aout, *amaster, *kamp, *kfreq;
	MYFLT	phase, masterlast;
} SYNC_SLAVE_DS;

typedef struct {
	OPDS	h;
	MYFLT	*aout, *kfreq;
	MYFLT	phase;
} SYNC_MASTER_DS;

typedef struct {
	OPDS	h;
	MYFLT	*aout, *kamp, *kmfreq, *kfreq;
	MYFLT	phase, masterphase, masterlast;
} SYNC_PAIR_DS;

typedef struct {
        OPDS    h;
        MYFLT   *sr, *async, *xamp, *xcps, *ifn, *iphs;
        long    lphs;
        FUNC    *ftp;
        MYFLT   synclast;
} SYNC_OSC_DS;

#endif
